$( document ).ready(function() {
    /*
     * managerHome
     */
    $('#addSensor').click(function(){
        $('#TipoSensor').removeClass('hiddenInput');
        $('#LocationSensor').removeClass('hiddenInput');
        $('#submitSensor').removeClass('hiddenInput');
    });
    
    $('#addLocation').click(function(){
        $('#nameLocation').removeClass('hiddenInput');
        $('#submitLocation').removeClass('hiddenInput');
    });
    
    $('.sensorbutton').click(function(){
        var clickedObj = $(this);
        var id = $(this).attr("id");
        var state = 0;
        if($(this).hasClass("cross")){ state = 0; }
        else{ state = 1; }
        
        $.post( '/manager/sensor/'+id+'/'+state, function(data) {
            $('#msgReturn').html(data).fadeIn(2000);
            if(state == 0){
                clickedObj.removeClass('cross').addClass('tick');
                clickedObj.attr("src","/static/images/tick.png");
                var td = clickedObj.parent().closest("td").prev();
                td.html("No");
            }else{
                clickedObj.removeClass('tick').addClass('cross');
                clickedObj.attr("src","/static/images/cross.png");
                var td = clickedObj.parent().closest("td").prev();
                td.html("Si");
            }
            $('#msgReturn').fadeOut(1500);
        });
        
    });
    
    $('#submitSensor').click(function(){
        if($('select[name=TipoSensor]').val() != '#' && $('select[name=LocationSensor]').val() != '#'){
            $('#formSensor').submit();
        }else{
            alert("Rellena todos los campos");
        }
    });
    
    $('#submitLocation').click(function(){
        if($('#nameLocation').val() != ''){
            $('#formLocation').submit();
        }else{
            alert("Rellena todos los campos");
        }
    });
    
    /*
     * managerMenu
     */
    $('#addMenu').click(function(){
        $('#contentAddPage h3').text("New item");
        $('#formMenu').attr('action', '/manager/add/menu');
        $('#formMenu input[type=text]').val('');
        
        $('#contentAddMenu').removeClass('hidden');
    });
    
    $('.editMenu').click(function(){
        $('#contentAddMenu h3').text("Edit item");
        $('#formMenu').attr('action', '/manager/edit/menu');
        var idmenu = $(this).closest('tr').children('td.idmenu').text();
        $.getJSON("/manager/menu/"+idmenu , function( data ) {
            $('#idEditMenu').val(data.id);
            $('#nameItem').val(data.nombre);
            $('#urlItem').val(data.url);
            $('#itemPadre').val(data.padre);
        });
        
        if($('#contentAddMenu').hasClass('hidden')) $('#contentAddMenu').removeClass('hidden');
    });
    
    $('.deleteMenu').click(function(){
        var idmenu = $(this).closest('tr').children('td.idmenu').text();
        var tr = $(this).closest('tr');
        if (confirm('¿Seguro que quiere eliminar este item?')) {
            $.post('/manager/delete/menu', { id: idmenu}, function(data){
                $('#msgReturn').html(data).fadeIn(2000);
                tr.remove();
            });
        }
    });
    
    $('#submitItem').click(function(){
       if($('#nameItem').val() != '' && $('#urlItem').val() != ''){
           $('#formMenu').submit();
       }else{
           alert("Rellena todos los campos");
       }
    });
    
    
    /*
     * managerPages
     */
    $('#addPage').click(function() {
        $('#contentAddPage h3').text("New Page");
        $('#formPage input[type=text], textarea').val('');
        $('#formPage input[type=radio]').prop('checked', false);
        $('#formPage').attr('action', '/manager/add/page');
        if($('#radiobtns').hasClass('hidden')) $('#radiobtns').removeClass('hidden');
        if(!$('#contentPage').hasClass('hidden')) $('#contentPage').addClass('hidden');
        if(!$('#chartsPage').hasClass('hidden')) $('#chartsPage').addClass('hidden');
        if(!$('#chartsTemplate').hasClass('hidden')) $('#chartsTemplate').addClass('hidden');
        if(!$('#chartsAvailables').hasClass('hidden')) $('#chartsAvailables').addClass('hidden');
        CKEDITOR.instances.contenido.setData('');
        
        $('#contentAddPage').removeClass('hidden');
    });

    $("#radiobtns input[name='pagetype_filter']").click(function(){
        if($('input:radio[name=pagetype_filter]:checked').val() == "1"){
            $('#chartsPage').addClass('hidden');
            $('#chartsTemplate').addClass('hidden');
            $('#contentPage').removeClass('hidden');
        }else{
            $('#contentPage').addClass('hidden');
            $('#chartsPage').removeClass('hidden');
            $('#chartsTemplate').removeClass('hidden');
        }
    });

    $('.editPage').click(function() {
        $('#contentAddPage h3').text("Edit page");
        $('#formPage').attr('action', '/manager/edit/page');
        $('#formPage input[type=text], textarea').val('');
        var idpage = $(this).closest('tr').children('td.idpage').text();
        var idtype = $(this).closest('tr').children('td.idtype').text();
        
        if(idtype == 1){
            if(!$('#chartsPage').hasClass('hidden')) $('#chartsPage').addClass('hidden');
            if(!$('#chartsTemplate').hasClass('hidden')) $('#chartsTemplate').addClass('hidden');
            if(!$('#chartsAvailables').hasClass('hidden')) $('#chartsAvailables').addClass('hidden');
            if($('#contentPage').hasClass('hidden')) $('#contentPage').removeClass('hidden');
            // cargamos el contenido de la pagina
            $.getJSON("/manager/page/"+idpage , function( data ) {
                $('#idEditPage').val(idpage);
                $('#titulo').val(data.titulo);
                $('#url').val(data.url);
                CKEDITOR.instances.contenido.setData(data.contenido);
            });
            $('#radiobtns').addClass('hidden');
            $('#contentAddPage').removeClass('hidden');
        }else{
            
            if($('#chartsPage').hasClass('hidden')) $('#chartsPage').removeClass('hidden');
            if(!$('#chartsTemplate').hasClass('hidden')) $('#chartsTemplate').addClass('hidden');
            if(!$('#chartsAvailables').hasClass('hidden')) $('#chartsAvailables').addClass('hidden');
            if(!$('#contentPage').hasClass('hidden')) $('#contentPage').addClass('hidden');
            $.getJSON("/manager/page/"+idpage , function( data ) {
                $('#idEditPage').val(idpage);
                $('#titulo').val(data.titulo);
                $('#url').val(data.url);
                $('#chartsPage').empty();
                var rows = '';
                for(var i=0; i< data.charts.length; i++){
                    rows += '<tr><td>'+data.charts[i].id+'</td><td>'+data.charts[i].nombre+'</td><td><img src="/static/images/cross.png" title="delete" class="deletePChart deleteimg" id="'+data.charts[i].id+'" /></td></tr>';
                }
                
                $('#chartsPage').append('<table class="table table-hover" id="chartPage"><tbody>'+rows+'</tbody></table>'+'<img src="/static/images/add.png" title="add" class="showChartToPage addimg" />');
                
            });
            
            $('#radiobtns').addClass('hidden');
            $('#contentAddPage').removeClass('hidden');
        }

        
    });
    
    $('body').on('click', 'img.deletePChart', function(){
        var idpage = $('#idEditPage').val();
        var idchart = $(this).attr('id');
        var tr = $(this).closest('tr');
        if (confirm('¿Seguro que quiere eliminar este grafico de la pagina?')) {
            $.post('/manager/delete/chartfrompage', { pid: idpage, cid: idchart}, function(data){
                $('#msgReturn').html(data).fadeIn(2000);
                tr.remove();
            });
        }
        
    });
    
    $('body').on('click', 'img.showChartToPage', function(){
        if($('#chartsAvailables').hasClass('hidden')) $('#chartsAvailables').removeClass('hidden');
        $('.showChartToPage').addClass('hidden');
    });
    
    $('#addChartToPage').click(function(){
        var idpage = $('#idEditPage').val();
        var idchart = $('#listCharts').val();
        var namechart = $("#listCharts option:selected").text();
        
        $.post('/manager/add/charttopage', { pid: idpage, cid: idchart}, function(data){
            $('#msgReturn').html(data).fadeIn(2000);
            $('#chartPage tbody').append('<tr><td>'+idchart+'</td><td>'+namechart+'</td><td><img src="/static/images/cross.png" title="delete" class="deleteChart deleteimg" id="'+idchart+'" /></td></tr>');
            $('#chartsAvailables').addClass('hidden');
            $('.showChartToPage').removeClass('hidden');
        });
    });
   
    $('#submitPage').click(function(){
        // validacion
        if($('#titulo').val() != '' && $('#url').val() != '' && ($('input:radio[name=pagetype_filter]:checked').val() > 0 || $('#formPage').attr('action') == '/manager/edit/page')){
            $('#formPage').submit();    
        }else{
            alert("Rellena todos los campos");
        }
        
    });
    
    $('.deletePage').click(function(){
        var idpage = $(this).closest('tr').children('td.idpage').text();
        var tr = $(this).closest('tr');
        if (confirm('¿Seguro que quiere eliminar esta pagina?')) {
            $.post('/manager/delete/page', { id: idpage}, function(data){
                $('#msgReturn').html(data).fadeIn(2000);
                tr.remove();
            });
        }
    });
    
    /*
     * Chart actions
     */
    $('.deleteChart').click(function(){
        var idchart = $(this).closest('tr').children('td.idchart').text();
        var tr = $(this).closest('tr');
        if (confirm('¿Seguro que quiere eliminar este grafico?')) {
            $.post('/manager/delete/chart', { id: idchart}, function(data){
                $('#msgReturn').html(data).fadeIn(2000);
                tr.remove();
            });
        }
    });
    
    $('.editChart').click(function(){
        
        $('#contentAddChart h3').text("Edit chart");
        $('#createChart').attr('action', '/manager/edit/chart');
        var idchart = $(this).closest('tr').children('td.idchart').text();
        $.getJSON("/manager/chart/"+idchart , function( data ) {
            $('#idEditChart').val(idchart);
            $('#nombre').val(data.nombre);
            $('#tipoGrafico').val(data.idtipo);
            $('#formatoGrafico').val(data.formato);
            $('#hasbtns').prop('checked', data.botones);
        });
        
    });
    
    $('#submitChart').click(function(){
        if($('#nombre').val() != '' && $('select[name=tipoGrafico]').val() != '#' && $('select[name=formatoGrafico]').val() != '#'){
            $('#createChart').submit();
        }else{
            alert("Rellena todos los campos (checkbox no obligactorio)");
        }
    });
    
    $('#submitConfig').click(function(){
       if($('#nInicial').val() != '' && $.isNumeric($('#nInicial').val()) && $('#nRealtime').val() != '' && $.isNumeric($('#nRealtime').val()) && $('#nSeg').val() != '' && $.isNumeric($('#nSeg').val())){
           $('#gConfig').submit();
       }else{
           alert("Los valores introducidos no son correctos");
       }
        
    });
   
    
});